/*****************************************************************************
*               qdosconf.h
*
*  This header file contains all constants and types required to run on a
*  QDOS/SMS system.
*
*  from Persistence of Vision Raytracer
*  Copyright 1995 Persistence of Vision Team
*---------------------------------------------------------------------------
*  NOTICE: This source code file is provided so that users may experiment
*  with enhancements to POV-Ray and to port the software to platforms other
*  than those supported by the POV-Ray Team.  There are strict rules under
*  which you are permitted to use this file.  The rules are in the file
*  named POVLEGAL.DOC which should be distributed with this file. If
*  POVLEGAL.DOC is not available or for more info please contact the POV-Ray
*  Team Coordinator by leaving a message in CompuServe's Graphics Developer's
*  Forum.  The latest version of POV-Ray may be found there as well.
*
* This program is based on the popular DKB raytracer version 2.12.
* DKBTrace was originally written by David K. Buck.
* DKBTrace Ver 2.0-2.12 were written by David K. Buck & Aaron A. Collins.
*
* Modifications (QDOS/SMS port) by Thierry Godefroy April 1999
*
*****************************************************************************/

/*
 * Below are several defines needed by the QDOS/SMS parts of POV.  You
 * may redefine them as needed in this config.h file. Each has a default
 * which will be defined in frame.h if you don't define it here.
 */

#define PARAMS(x) x
#define CONST const
#include <stdlib.h>
#include <unistd.h>

#define DISTRIBUTION_MESSAGE_1 "This is the QDOS/SMS port by:"
#define DISTRIBUTION_MESSAGE_2 "Thierry Godefroy (godefroy@imaginet.fr)."

/* QDOS specific routines in qdos_c */

#define STARTUP_POVRAY QDOS_init();
void QDOS_init(void);

#define READ_ENV_VAR QDOS_process_env();
void QDOS_process_env(void);

#define PROCESS_POVRAY_INI QDOS_process_povray_ini();
void QDOS_process_povray_ini(void);

#define FINISH_POVRAY {QDOS_exit(); exit(0);}
void QDOS_exit(void);

#define TEST_ABORT QDOS_test_abort();
void QDOS_test_abort(void);

#define WAIT_FOR_KEYPRESS getchar();

#define POV_BANNER(s)       QDOS_console_print(s)
#define POV_WARNING(s)      QDOS_console_print(s)
#define POV_RENDER_INFO(s)  QDOS_console_print(s)
#define POV_STATUS_INFO(s)  QDOS_console_print(s)
#define POV_DEBUG_INFO(s)   QDOS_console_print(s)
#define POV_FATAL(s)        QDOS_console_print(s)
#define POV_STATISTICS(s)   QDOS_console_print(s)
void QDOS_console_print(char *s);

#define POV_DISPLAY_INIT(w,h) QDOS_display_init(w,h);
void QDOS_display_init(int Width, int Height);

#define POV_DISPLAY_FINISHED QDOS_display_finished();
void QDOS_display_finished(void);

#define POV_DISPLAY_CLOSE QDOS_display_close();
void QDOS_display_close(void);

#define POV_DISPLAY_PLOT(x,y,r,g,b,a) QDOS_display_plot(x,y,r,g,b,a);
void QDOS_display_plot(int x, int y, unsigned char Red, unsigned char Green,
                       unsigned char Blue, unsigned char Alpha);

#define COMPILER_VER ""

#define POV_NAME_MAX 39
#define FILE_NAME_MAX 39
#define FILENAME_SEPARATOR '_'
#define DRIVE_SEPARATOR '_'
#define POV_SPLIT_PATH(s,p,f) QDOS_split_filename(s,p,f);
int QDOS_split_filename(char *s, char *p, char *f);

/*
 * Define the default location of the POV-Ray library
 */
#ifndef POV_LIB_DIR
#define POV_LIB_DIR    "win5_POV_lib"
#endif

#define TIME_ELAPSED (tstop - tstart);

/*
 * What level of memory statistics we want.  See mem.h for more info.
 */
#define MEM_STATS 1

#define PRECISION_TIMER_AVAILABLE 0

#define MAIN_RETURN_TYPE       int
#define MAIN_RETURN_STATEMENT  return(0);
